=begin
#API from Wineshipping

#Wineshipping API is a programmatically consumable service or an Application Programming Interface (API) platform designed to enable Wineshipping LLC's client applications to natively transmit and manage their order, view inventory, track shipments etc.<br /><br />In order to access API operations request a UserKey and Password from Wineshipping. For any questions please contact Wineshipping Helpdesk at <a href='mailto:IT-Help@wineshipping.com?Subject=API from Wineshipping'>IT-Help@wineshipping.com</a>.

OpenAPI spec version: V3

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

# Common files
require 'wine_shipping/api_client'
require 'wine_shipping/api_error'
require 'wine_shipping/version'
require 'wine_shipping/configuration'

# Models
require 'wine_shipping/models/authentication'
require 'wine_shipping/models/billing_contact_info'
require 'wine_shipping/models/delivery_contact_info'
require 'wine_shipping/models/inventory'
require 'wine_shipping/models/inventory_status_request'
require 'wine_shipping/models/inventory_status_result'
require 'wine_shipping/models/item_info'
require 'wine_shipping/models/order_on_hold'
require 'wine_shipping/models/order_on_hold_item'
require 'wine_shipping/models/package_item'
require 'wine_shipping/models/purchase_order_details'
require 'wine_shipping/models/purchase_order_info'
require 'wine_shipping/models/purchase_order_item_info'
require 'wine_shipping/models/recipient_contact_info'
require 'wine_shipping/models/requestor_info'
require 'wine_shipping/models/return_result'
require 'wine_shipping/models/return_sales_order_header'
require 'wine_shipping/models/return_sales_order_line'
require 'wine_shipping/models/returns_request'
require 'wine_shipping/models/sku_details'
require 'wine_shipping/models/sku_info'
require 'wine_shipping/models/sales_order_cancel_request'
require 'wine_shipping/models/sales_order_details'
require 'wine_shipping/models/sales_order_info'
require 'wine_shipping/models/shipment_info'
require 'wine_shipping/models/tracking_request'
require 'wine_shipping/models/tracking_result'
require 'wine_shipping/models/transfer_order_details'
require 'wine_shipping/models/transfer_order_info'
require 'wine_shipping/models/transfer_order_item_info'
require 'wine_shipping/models/warehouse_inventory_status'

# APIs
require 'wine_shipping/api/inventory_api'
require 'wine_shipping/api/inventory_movement_api'
require 'wine_shipping/api/sku_api'
require 'wine_shipping/api/sales_order_api'
require 'wine_shipping/api/tracking_api'

module WineShipping
  class << self
    # Customize default settings for the SDK using block.
    #   WineShipping.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
