=begin
#API from Wineshipping

#Wineshipping API is a programmatically consumable service or an Application Programming Interface (API) platform designed to enable Wineshipping LLC's client applications to natively transmit and manage their order, view inventory, track shipments etc.<br /><br />In order to access API operations request a UserKey and Password from Wineshipping. For any questions please contact Wineshipping Helpdesk at <a href='mailto:IT-Help@wineshipping.com?Subject=API from Wineshipping'>IT-Help@wineshipping.com</a>.

OpenAPI spec version: V3

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.7

=end

require 'uri'

module WineShipping
  class TrackingApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # This operation provides sales order and associated package tracking information and their status if available. This operation accepts a customer number and order number to locate the order information within the Wineshipping system. The result will include individual packages, associated tracking numbers, carrier status, and the shipping address information.
    # @param track_order 
    # @param [Hash] opts the optional parameters
    # @return [Array<TrackingResult>]
    def get_details(track_order, opts = {})
      data, _status_code, _headers = get_details_with_http_info(track_order, opts)
      data
    end

    # This operation provides sales order and associated package tracking information and their status if available. This operation accepts a customer number and order number to locate the order information within the Wineshipping system. The result will include individual packages, associated tracking numbers, carrier status, and the shipping address information.
    # @param track_order 
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<TrackingResult>, Fixnum, Hash)>] Array<TrackingResult> data, response status code and response headers
    def get_details_with_http_info(track_order, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TrackingApi.get_details ...'
      end
      # verify the required parameter 'track_order' is set
      if @api_client.config.client_side_validation && track_order.nil?
        fail ArgumentError, "Missing the required parameter 'track_order' when calling TrackingApi.get_details"
      end
      # resource path
      local_var_path = '/api/Tracking/GetDetails'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(track_order)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'Array<TrackingResult>')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TrackingApi#get_details\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
